
precision highp float;
varying highp vec2 textureCoordinate;
uniform sampler2D inputImageTexture;
uniform vec2 singleStepOffset;

vec4 avgRGBColor(sampler2D inputImageTexture,vec2 textureCoordinate){
  vec4 sampleColor=vec4(0.0,0.0,0.0,0.0);
  for(float i = 0.0;i<10.0;i++){  //行
    for(float j = 0.0;j<10.0;j++){  //列
        float x=textureCoordinate.x+singleStepOffset.x*3.0*(i-5.0);
        float y=textureCoordinate.y+singleStepOffset.y*3.0*(j-5.0);
        sampleColor += texture2D(inputImageTexture, vec2(x,y));
    }
  }
   sampleColor = sampleColor / 100.0;
  return sampleColor;
}

float hardLight(float color)
{
  if(color <= 0.5){
      color = color * color * 2.0;
  }else{
      color = 1.0 - ((1.0 - color)*(1.0 - color) * 2.0);
  }
  return color;
}

void main()
{
    vec2 coordinate = vec2(textureCoordinate.x,  textureCoordinate.y);
    vec4 originColor = texture2D(inputImageTexture, textureCoordinate);
    vec4 sampleColor = avgRGBColor(inputImageTexture,textureCoordinate);

    vec4 newColor = originColor - sampleColor + 0.5;

    for(int i = 0; i < 2;i++)
     {
        newColor.b = hardLight(newColor.b);
     }

    gl_FragColor = vec4(newColor.b,newColor.b,newColor.b,1.0);
}