precision highp float;

varying highp vec2 textureCoordinate;
uniform sampler2D inputImageTexture;  //blur图
uniform sampler2D inputImageTexture2;  //mask图
uniform sampler2D inputImageTexture3;   //原图
uniform lowp float mixCOEF;

uniform lowp vec2 pos43;
uniform lowp vec2 pos49;

bool isRed(vec4 color){
    return color.r>0.0;
}

bool isBlack(vec4 color){
    return color.r<0.5;
}


vec4 getColor(vec2 coord){
    vec4 color=texture2D(inputImageTexture2,coord);
    return color;
}

//
vec4 getReplaceColor(vec2 currentPos){
    vec4 colorBlur = texture2D(inputImageTexture,currentPos);
    vec4 colorMask = texture2D(inputImageTexture2, currentPos);
    vec4 colorOri = texture2D(inputImageTexture3, currentPos);
    vec4 replaceColor = mix(colorOri,colorBlur,colorMask.r);
    return replaceColor;

}

void main()
{
//    gl_FragColor = texture2D(inputImageTexture, textureCoordinate);

    gl_FragColor = texture2D(inputImageTexture3, textureCoordinate);
    if(isRed(texture2D(inputImageTexture2, textureCoordinate))){
        vec4 replaceColor =  getReplaceColor(textureCoordinate);
        gl_FragColor = vec4(replaceColor.rgb,1.0);
    }
}
