
precision highp float;
varying highp vec2 textureCoordinate;
uniform sampler2D inputImageTexture;
uniform sampler2D inputImageTexture2;

uniform lowp vec2 location0;
uniform lowp vec2 location1;
uniform lowp vec2 location2;
uniform lowp vec2 location3;
uniform lowp vec2 location4;
uniform lowp vec2 location5;
uniform lowp vec2 location6;
uniform lowp vec2 location7;
uniform lowp vec2 location8;

uniform lowp vec2 location9;
uniform lowp vec2 location10;
uniform lowp vec2 location11;
uniform lowp vec2 location12;
uniform lowp vec2 location13;
uniform lowp vec2 location14;
uniform lowp vec2 location15;
uniform lowp vec2 location16;
uniform lowp vec2 location17;

#define p33     location0
#define p34     location1
#define p35     location2
#define p36     location3
#define p37     location4
#define p67     location5
#define p66     location6
#define p65     location7
#define p64     location8

#define p42     location9
#define p41     location10
#define p40     location11
#define p39     location12
#define p38     location13
#define p68     location14
#define p69     location15
#define p70     location16
#define p71     location17

bool isInPolygon(vec2 point,vec2 points[9],float n) {
    float nCross = 0.0;
    for (float i = 0.0; i < n; i++) {
        vec2 p1 = points[int(i)];
        vec2 p2 = points[int(mod(i+1.0,n))];
        // 求解 y=p.y 与 p1 p2 的交点
        // p1p2 与 y=p0.y平行
        if (p1.y == p2.y){
            
            continue;
        }
        
        // 交点在p1p2延长线上
        if (point.y < min(p1.y, p2.y)){
            
            continue;
        }
        
        // 交点在p1p2延长线上
        if (point.y >= max(p1.y, p2.y)){
            
            continue;
        }
        
        // 求交点的 X 坐标
        float x =  (point.y - p1.y) * (p2.x - p1.x)
        / (p2.y - p1.y) + p1.x;
        
        // 只统计单边交点
        if (x >= point.x){
            
            nCross++;
        }
    }
    return (int(mod(nCross,2.0)) == 1);
}

bool isBlackColor(vec2 textureCoordinate,sampler2D inputImageTexture)
{
    vec4 color = texture2D(inputImageTexture,textureCoordinate);
    
    if(color.b <= 0.5){
        return true;
    }
    return false;
}

void main()
{
    vec4 originColor = texture2D(inputImageTexture,textureCoordinate);
    
    gl_FragColor = originColor;
    
    vec2 curCoord = textureCoordinate;
    
    float aspect = 1.0;
    vec2 leftBrowAroundPoints[9];
    vec2 leftBrow[9];
    float leftHeight = (p65.y - p35.y) / 2.0;
    
    vec2 lp0 = vec2(location0.x,location0.y-leftHeight);
    leftBrowAroundPoints[0] = lp0;
    leftBrow[0] = location0;
    vec2 lp1 = vec2(location1.x,location1.y-leftHeight);
    leftBrowAroundPoints[1] = lp1;
    leftBrow[1] = location1;
    vec2 lp2 = vec2(location2.x,location2.y-leftHeight);
    leftBrowAroundPoints[2] = lp2;
    leftBrow[2] = location2;
    vec2 lp3 = vec2(location3.x,location3.y-leftHeight);
    leftBrowAroundPoints[3] = lp3;
    leftBrow[3] = location3;
    vec2 lp4 = vec2(location4.x,location4.y-leftHeight);
    leftBrowAroundPoints[4] = lp4;
    leftBrow[4] = location4;
//    vec2 lp5 = vec2(location5.x+leftHeight,location5.y+leftHeight);
    vec2 lp5 = location5;
    leftBrowAroundPoints[5] = lp5;
    leftBrow[5] = vec2(location5.x*0.995,location5.y*0.995);
    vec2 lp6 = vec2(location6.x,location6.y+leftHeight/2.0);
    leftBrowAroundPoints[6] = lp6;
    leftBrow[6] = location6;
    vec2 lp7 = vec2(location7.x,location7.y+leftHeight/2.0);
    leftBrowAroundPoints[7] = lp7;
    leftBrow[7] = location7;
    vec2 lp8 = vec2(location8.x,location8.y+leftHeight/2.0);
    leftBrowAroundPoints[8] = lp8;
    leftBrow[8] = location8;
    
    vec2 rightBrowAroundPoints[9];
    vec2 rightBrow[9];
    float rightHeight = (p70.y - p40.y) / 2.0;
    
    vec2 rp0 = vec2(location9.x,location9.y-rightHeight);
    rightBrowAroundPoints[0] = rp0;
    rightBrow[0] = location9;
    vec2 rp1 = vec2(location10.x,location10.y-rightHeight);
    rightBrowAroundPoints[1] = rp1;
    rightBrow[1] = location10;
    vec2 rp2 = vec2(location11.x,location11.y-rightHeight);
    rightBrowAroundPoints[2] = rp2;
    rightBrow[2] = location11;
    vec2 rp3 = vec2(location12.x,location12.y-rightHeight);
    rightBrowAroundPoints[3] = rp3;
    rightBrow[3] = location12;
    vec2 rp4 = vec2(location13.x,location13.y-rightHeight);
    rightBrowAroundPoints[4] = rp4;
    rightBrow[4] = location13;
//    vec2 rp5 = vec2(location14.x-rightHeight,location14.y+rightHeight);
    vec2 rp5 = location14;
    rightBrowAroundPoints[5] = rp5;
    rightBrow[5] = vec2(location14.x*1.005,location14.y*0.995);
    vec2 rp6 = vec2(location15.x,location15.y+rightHeight/2.0);
    rightBrowAroundPoints[6] = rp6;
    rightBrow[6] = location15;
    vec2 rp7 = vec2(location16.x,location16.y+rightHeight/2.0);
    rightBrowAroundPoints[7] = rp7;
    rightBrow[7] = location16;
    vec2 rp8 = vec2(location17.x,location17.y+rightHeight/2.0);
    rightBrowAroundPoints[8] = rp8;
    rightBrow[8] = location17;
    
    vec4 sameColor = vec4(0.0,0.0,0.0,1.0);
    
    if(isInPolygon(curCoord,leftBrow,9.0))
    {
        vec4 tempColor = vec4(0.0,0.0,0.0,1.0);
        float count = 0.0;
        for (float i = 0.0; i < 9.0; i++)
        {
            vec2 point = leftBrowAroundPoints[int(i)];
            if (!isBlackColor(point,inputImageTexture2)) {
                
                count ++;
                
                vec4 color = texture2D(inputImageTexture, point);
                tempColor += color;
            }
            
        }
        
        if (count > 4.0) {
            sameColor = tempColor / count;
        }
        else
        {
            sameColor = originColor;
        }
        
        gl_FragColor = sameColor;
    }
    
    
    if(isInPolygon(curCoord,rightBrow,9.0))
    {
        vec4 tempColor = vec4(0.0,0.0,0.0,1.0);
        float count = 0.0;
        for (float i = 0.0; i < 9.0; i++)
        {
            vec2 point = rightBrowAroundPoints[int(i)];
            if (!isBlackColor(point,inputImageTexture2)) {
                
                count ++;
                
                vec4 color = texture2D(inputImageTexture, point);
                tempColor += color;
            }
        }
        
        if (count > 4.0) {
            sameColor = tempColor / count;
        }
        else
        {
            sameColor = originColor;
        }
        
//        if (isBlackColor(curCoord,inputImageTexture2)) {
//            sameColor = originColor;
//        }
        gl_FragColor = sameColor;
    }
}
