precision highp float;
varying highp vec2 textureCoordinate;
varying highp vec2 textureCoordinate2;
uniform sampler2D inputImageTexture;
uniform sampler2D inputImageTexture2;
uniform lowp float mixCOEF;
uniform lowp float isOrigin;
uniform lowp vec4 colorRGBTexture;

highp vec4 blendColorMultiply(highp vec4 c1,highp vec4 c2){
    highp vec4 outputColorMultiply = vec4(c1.r*c2.r,c1.g*c2.g,c1.b*c2.b,1.0);
    return outputColorMultiply;
}

highp vec4 blendNormal(highp vec4 c1, highp vec4 c2,highp float mixB)
{
    vec4 outputColor;
    outputColor.r = c1.r*mixB + c2.r * c2.a * (1.0 - c1.a*mixB);
    outputColor.g = c1.g*mixB + c2.g * c2.a * (1.0 - c1.a*mixB);
    outputColor.b = c1.b*mixB + c2.b * c2.a * (1.0 - c1.a*mixB);
    outputColor.a = c1.a + c2.a * (1.0 - c1.a);
    return outputColor;
}

void main(){
    highp vec4 abc = texture2D(inputImageTexture, textureCoordinate);   //第一次画原图   第二次是素材
    if(isOrigin > 0.5){
       gl_FragColor = abc;  //原图
    }else{
            highp vec4 oriColor = texture2D(inputImageTexture2, textureCoordinate2);
            highp vec4 replaceColor = vec4(colorRGBTexture.rgb*(1.0 - abc.g),(1.0 - abc.g));  //透明带色眉毛

            highp vec4 mixColor = blendNormal(replaceColor,vec4(1.0,1.0,1.0,1.0),replaceColor.a);       //白底带色眉毛
            highp vec4 blendColorM = blendColorMultiply(oriColor,mixColor);
            gl_FragColor = vec4(mix(oriColor.rgb,blendColorM.rgb,mixCOEF),1.0);
     }
}
