precision highp float;
varying highp vec2 textureCoordinate;
varying highp vec2 textureCoordinate2;  //人眼区域mask图坐标
varying highp vec2 textureCoordinate3;  //lookuptable
uniform sampler2D inputImageTexture;
uniform sampler2D inputImageTexture2;
uniform sampler2D inputImageTexture3;

uniform lowp float isOrigin;
uniform lowp float eyeLightRatio;
//uniform lowp float mixturePercent;

uniform lowp vec2 eyeCenter_l;
uniform lowp vec2 eyeCorner_l1;
uniform lowp vec2 eyeCorner_l2;

uniform lowp vec2 eyeCenter_r;
uniform lowp vec2 eyeCorner_r1;
uniform lowp vec2 eyeCorner_r2;

#define x_a 0.5625

highp vec4 getEyeLightColor(highp vec4 textureColor){

       highp float blueColor = textureColor.b * 15.0;

       highp vec2 quad1;
       quad1.y = floor(floor(blueColor) / 4.0);
       quad1.x = floor(blueColor) - (quad1.y * 4.0);

       highp vec2 quad2;
       quad2.y = floor(ceil(blueColor) / 4.0);
       quad2.x = ceil(blueColor) - (quad2.y * 4.0);

       highp vec2 texPos1;
       texPos1.x = (quad1.x * 0.25) + 0.5/64.0 + ((0.25 - 1.0/64.0) * textureColor.r);
       texPos1.y = (quad1.y * 0.25) + 0.5/64.0 + ((0.25 - 1.0/64.0) * textureColor.g);

       highp vec2 texPos2;
       texPos2.x = (quad2.x * 0.25) + 0.5/64.0 + ((0.25 - 1.0/64.0) * textureColor.r);
       texPos2.y = (quad2.y * 0.25) + 0.5/64.0 + ((0.25 - 1.0/64.0) * textureColor.g);

       lowp vec4 newColor1 = texture2D(inputImageTexture3, texPos1);
       lowp vec4 newColor2 = texture2D(inputImageTexture3, texPos2);

       lowp vec4 newColor = mix(newColor1, newColor2, fract(blueColor));

       highp vec4 textureColor2 = vec4(newColor.rgb, textureColor.w);
       return textureColor2;
}

void main(){
    highp vec4 abc = texture2D(inputImageTexture, textureCoordinate);

    if(isOrigin > 0.5){
        gl_FragColor = abc;
    }else{

            highp vec4 maskRegionColor = texture2D(inputImageTexture2, textureCoordinate2);

            lowp float disL = distance(vec2(eyeCorner_l1.x*x_a,eyeCorner_l1.y),vec2(eyeCorner_l2.x*x_a,eyeCorner_l2.y))*0.2 - distance(vec2(textureCoordinate.x*x_a,textureCoordinate.y), vec2(eyeCenter_l.x*x_a,eyeCenter_l.y));
            lowp float disR = distance(vec2(eyeCorner_r1.x*x_a,eyeCorner_r1.y),vec2(eyeCorner_r2.x*x_a,eyeCorner_r2.y))*0.2 - distance(vec2(textureCoordinate.x*x_a,textureCoordinate.y), vec2(eyeCenter_r.x*x_a,eyeCenter_r.y));
            lowp float ratioA = clamp(step(disL,0.0) + step(disR,0.0),0.0,1.0);
            highp vec4 textureColor_face = texture2D(inputImageTexture, textureCoordinate);  //人脸
            highp vec4 textureColor2 = getEyeLightColor(textureColor_face);
            gl_FragColor = vec4(mix(textureColor_face.rgb, textureColor2.rgb, textureColor2.a*eyeLightRatio)*maskRegionColor.g*ratioA, maskRegionColor.g*ratioA);

     }
}
