precision highp float;

varying highp vec2 textureCoordinate;   //底图坐标
varying highp vec2 textureCoordinate2;  //人眼区域mask图坐标
//varying highp vec2 textureCoordinate3;

uniform sampler2D inputImageTexture;//底图
uniform sampler2D inputImageTexture2;//人眼区域mask
uniform sampler2D inputImageTexture3;//美瞳素材

uniform lowp float mixCOEF;
uniform lowp float sizeRatio;
uniform lowp float isOrigin;

uniform lowp vec2 textureSize;

uniform lowp vec2 eyeCenter;
uniform lowp vec2 eyeCorner1;
uniform lowp vec2 eyeCorner2;

void main(){

    if(isOrigin > 0.5){
        vec4 oriColor = texture2D(inputImageTexture, textureCoordinate);
        gl_FragColor = oriColor;
    }else{
        vec4 maskRegionColor = texture2D(inputImageTexture2, textureCoordinate2);
       if(maskRegionColor.g>0.0){
           vec2 realEyeCenter=vec2(eyeCenter.x*textureSize.x,eyeCenter.y*textureSize.y);
           vec2 realEyeCorner1=vec2(eyeCorner1.x*textureSize.x,eyeCorner1.y*textureSize.y);
           vec2 realEyeCorner2=vec2(eyeCorner2.x*textureSize.x,eyeCorner2.y*textureSize.y);
           vec2 realCurCoord=vec2(textureCoordinate.x*textureSize.x,textureCoordinate.y*textureSize.y);

           float eyeRadius=distance(realEyeCorner1,realEyeCorner2)*0.25*sizeRatio;
           float disToCenter=distance(realCurCoord,realEyeCenter);
           if(disToCenter<eyeRadius){
               vec2 realDirection=realCurCoord-realEyeCenter;
               vec2 direction=vec2(realDirection.x/eyeRadius,realDirection.y/eyeRadius);

               vec2 texture3Coord=vec2(0.5,0.5)+0.5*direction;
               vec4 scColor = texture2D(inputImageTexture3, texture3Coord);
               gl_FragColor = vec4(scColor.rgb*scColor.a*mixCOEF*maskRegionColor.g,scColor.a*mixCOEF*maskRegionColor.g);
           }else{
               gl_FragColor = vec4(0.0,0.0,0.0,0.0);
           }
//               gl_FragColor = vec4(1.0,0.0,0.0,1.0);
       }else{
           gl_FragColor = vec4(0.0,0.0,0.0,0.0);
//           gl_FragColor = vec4(1.0,1.0,0.0,1.0);
       }
     }
}
