precision highp float;

varying highp vec2 textureCoordinate;
varying highp vec2 textureCoordinate2;

uniform sampler2D inputImageTexture;
uniform sampler2D inputImageTexture2;

uniform lowp float mixCOEF;
uniform lowp float isOrigin;
uniform lowp vec2 singleStepOffset;

vec4 blendNormal(vec4 c1, vec4 c2,float mixB)
{
    vec4 outputColor;
    outputColor.r = c1.r*mixB + c2.r * c2.a * (1.0 - c1.a*mixB);
    outputColor.g = c1.g*mixB + c2.g * c2.a * (1.0 - c1.a*mixB);
    outputColor.b = c1.b*mixB + c2.b * c2.a * (1.0 - c1.a*mixB);
    outputColor.a = c1.a + c2.a * (1.0 - c1.a);
    return outputColor;
}

vec4 blendColorMultiply(vec4 c1,vec4 c2){
    vec4 outputColorMultiply = vec4(c1.r*c2.r,c1.g*c2.g,c1.b*c2.b,1.0);
    return outputColorMultiply;
}

void main(){
    vec4 oriColor = texture2D(inputImageTexture, textureCoordinate);
    if(isOrigin > 0.5){
        gl_FragColor = oriColor;
    }else{
        vec4 maskColor = texture2D(inputImageTexture2, textureCoordinate2);
        vec4 blendColorM = blendColorMultiply(maskColor,oriColor);
        vec4 blendColor = vec4(mix(oriColor.rgb,blendColorM.rgb,mixCOEF),1.0);
        gl_FragColor = blendColor;
     }
}
