precision highp float;
varying highp vec2 textureCoordinate;
varying highp vec2 textureCoordinate2;
uniform sampler2D inputImageTexture;
uniform sampler2D inputImageTexture2;
uniform lowp float isOrigin;
uniform lowp vec2 centerPos;
uniform lowp vec2 vecLeft;


//点到直线的距离，lineP1、lineP2是过直线的两点
vec2 getPosPointToLine(vec2 pt1,vec2 pt2,vec2 pt3){
        float A = (pt1.y-pt2.y)/(pt1.x- pt2.x);
        float B = (pt1.y-A*pt1.x);
        /// > 0 = ax +b -y;  对应垂线方程为 -x -ay + m = 0;(mm为系数)
        /// > A = a; B = b;
        float m = pt3.x + A*pt3.y;

        /// 求两直线交点坐标
        float x = (m-A*B)/(A*A + 1.0);
        float y = A*x+B;
        return vec2(x,y);
}

void main(){
    highp vec4 abc = texture2D(inputImageTexture, textureCoordinate);   //第一次画原图   第二次是画原图
    if(isOrigin > 0.5){
       gl_FragColor = abc;  //原图
    }else{
        
        //根据距离求出的应增强强度
        lowp float dis_y = abs(textureCoordinate2.y - 0.75);

        lowp float ratio_y =dis_y/(0.75 - 0.5*step(0.75,textureCoordinate2.y));

//
        lowp float dis_x = abs(textureCoordinate2.x - 0.5);
        lowp float ratio_x = dis_x/0.5; //ratio_x越大，横向距离中心越远
        ratio_x = step(0.88,ratio_x)*((1.0 -ratio_x)/0.12 - 1.0) + 1.0;


        lowp float isRatioMoreHalf = step(0.5,ratio_y);

        //最高点0.25
       lowp float infect = 1.0+isRatioMoreHalf*(-ratio_y+1.0)*0.5*ratio_x
              + (1.0 - isRatioMoreHalf)*ratio_y*0.5*ratio_x;
//        gl_FragColor = vec4(1.0,0.0,0.0,1.0*ratio_y*ratio_x);


        lowp vec2 crossOverPoint_h = getPosPointToLine(centerPos,centerPos+vecLeft,textureCoordinate);
        lowp vec2 directionVec_h = (textureCoordinate - crossOverPoint_h)*infect;
        highp vec4 resultColor = texture2D(inputImageTexture, crossOverPoint_h+directionVec_h);
//        highp vec4 resultColor = texture2D(inputImageTexture, textureCoordinate+textureCoordinate - crossOverPoint_h);
        gl_FragColor = vec4(resultColor.rgb,1.0);
//        gl_FragColor = vec4(1.0,1.0,0.0,0.5);
     }
}
