
precision highp float;
precision highp int;

varying highp vec2 textureCoordinate;
uniform sampler2D inputImageTexture;
uniform sampler2D inputImageTexture2;

uniform float ratio;

vec4 getColor(vec2 coord){
    return texture2D(inputImageTexture2,coord);
}

bool isNoseShadowRegion(vec2 coord){
    vec4 color=getColor(coord);
    return color.r>0.0;
}

void main()
{
    vec4 curColor=texture2D(inputImageTexture,textureCoordinate);
    gl_FragColor = curColor;
    vec3 black=vec3(0.0,0.0,0.0);
    if(isNoseShadowRegion(textureCoordinate)){
        vec4 maskColor=getColor(textureCoordinate);
        vec3 color=mix(curColor.rgb,black,maskColor.r*ratio);
        gl_FragColor = vec4(color,curColor.a);
    }
}
