precision highp float;
varying highp vec2 textureCoordinate;
varying highp vec2 textureCoordinate2;
varying highp vec2 textureCoordinate3;
varying highp vec2 textureCoordinate4;
uniform sampler2D inputImageTexture;
uniform sampler2D inputImageTexture2;
uniform sampler2D inputImageTexture3;
uniform sampler2D inputImageTexture4;
uniform lowp float mixCOEF;
uniform lowp float mixCOEFBlur;
uniform lowp float isOrigin;
uniform lowp vec4 colorRGBTexture;

highp vec4 blendColorMultiply(highp vec4 c1, highp vec4 c2){
    highp vec4 outputColorMultiply = vec4(c1.r*c2.r, c1.g*c2.g, c1.b*c2.b, 1.0);
    return outputColorMultiply;
}

highp vec4 blendNormal(highp vec4 c1, highp vec4 c2, highp float mixB)
{
    vec4 outputColor;
    outputColor.r = c1.r*mixB + c2.r * c2.a * (1.0 - c1.a*mixB);
    outputColor.g = c1.g*mixB + c2.g * c2.a * (1.0 - c1.a*mixB);
    outputColor.b = c1.b*mixB + c2.b * c2.a * (1.0 - c1.a*mixB);
    outputColor.a = c1.a + c2.a * (1.0 - c1.a);
    return outputColor;
}

void main(){
    highp vec4 abc = texture2D(inputImageTexture, textureCoordinate);
    if (isOrigin > 0.5){
        gl_FragColor = abc;
    } else {

        highp vec4 oriColor_remove = texture2D(inputImageTexture3, textureCoordinate2);
        highp vec4 oriColor_noremove = texture2D(inputImageTexture4, textureCoordinate2);
        highp vec4 maskColor = texture2D(inputImageTexture2, textureCoordinate2);//mask图

        highp vec4 oriColor_blend = vec4(mix(oriColor_remove.rgb, oriColor_noremove.rgb, mixCOEFBlur), 1.0);
        highp vec4 replaceColor = vec4(colorRGBTexture.rgb*(1.0 - abc.r)*maskColor.r, (1.0 - abc.r)*maskColor.r);
        highp vec4 mixColor = blendNormal(replaceColor, vec4(1.0, 1.0, 1.0, 1.0), replaceColor.a);
        highp vec4 blendColorM = blendColorMultiply(oriColor_blend, mixColor);
        gl_FragColor = vec4(mix(oriColor_blend.rgb, blendColorM.rgb, mixCOEF), 1.0);
    }
}
