
precision highp float;
varying highp vec2 textureCoordinate;

uniform sampler2D inputImageTexture;
uniform sampler2D inputImageTexture2;


uniform lowp vec2 location0;
uniform lowp vec2 location1;

//调节眼睛放大程度，值越大眼睛放大程度越大
//最佳值0.3，值为0.0时无放大眼睛效果
uniform float ratio;

//the center point of left eye
#define p74     location0
//the center point of right eye
#define p77     location1

void main()
{
    
    gl_FragColor= texture2D(inputImageTexture,textureCoordinate);
    vec4 maskColor= texture2D(inputImageTexture2,textureCoordinate);
    vec2 curCoord= textureCoordinate;

    //enlarge eyes
    if(maskColor.r>0.5&&maskColor.g<0.5&&maskColor.b<0.5)
    {
        curCoord    = (curCoord-p74)*(1.0-ratio*0.1)+p74;
    }
    else if(maskColor.r<0.5&&maskColor.g>0.5&&maskColor.b<0.5)
    {
        curCoord    = (curCoord-p77)*(1.0-ratio*0.1)+p77;
    }
    
    gl_FragColor    = texture2D(inputImageTexture, curCoord);
}
