precision highp float;

varying highp vec2 textureCoordinate;   //人眼区域mask图坐标
varying highp vec2 textureCoordinate2;  //美瞳素材图坐标

uniform sampler2D inputImageTexture;
uniform sampler2D inputImageTexture2;

uniform lowp float mixCOEF;
uniform lowp float isOrigin;
uniform lowp vec4 colorRGBTexture;
uniform lowp vec4 colorSkinAvgRGB;
uniform lowp vec2 singleStepOffset;


vec4 blendNormal(vec4 c1, vec4 c2,float mixB)
{
    vec4 outputColor;
    outputColor.r = c1.r*mixB + c2.r * c2.a * (1.0 - c1.a*mixB);
    outputColor.g = c1.g*mixB + c2.g * c2.a * (1.0 - c1.a*mixB);
    outputColor.b = c1.b*mixB + c2.b * c2.a * (1.0 - c1.a*mixB);
    outputColor.a = c1.a + c2.a * (1.0 - c1.a);
    return outputColor;
}

void main(){
    if(isOrigin > 0.5){
        vec4 oriColor = texture2D(inputImageTexture, textureCoordinate);
        gl_FragColor = oriColor;
    }else{
        vec4 maskRegionColor = texture2D(inputImageTexture, textureCoordinate);
        vec4 scColor = texture2D(inputImageTexture2, textureCoordinate2);
//        if(maskRegionColor.r>0.5){
//            gl_FragColor = vec4(scColor.rgb*scColor.a*mixCOEF,scColor.a*mixCOEF);
//        }else{
//            gl_FragColor = vec4(0.0,0.0,0.0,0.0);
//        }
        if(maskRegionColor.r>0.0){
            gl_FragColor = vec4(scColor.rgb*scColor.a*mixCOEF*maskRegionColor.r,scColor.a*mixCOEF*maskRegionColor.r);
        }else{
            gl_FragColor = vec4(0.0,0.0,0.0,0.0);
        }
     }
}
