
precision highp float;
varying highp vec2 textureCoordinate;
uniform sampler2D inputImageTexture;
uniform sampler2D inputImageTexture2;
uniform sampler2D inputImageTexture3;
uniform lowp vec2 leftEye[16];
uniform lowp vec2 rightEye[16];
uniform lowp vec2 leftSkinPos;
uniform lowp vec2 rightSkinPos;
uniform lowp vec4 colorRGBTexture;
uniform lowp float isNeedAvoid;

//人脸坐标
uniform lowp vec2 noseCenterLeft;
uniform lowp vec2 eyebrowCenterLeft;
uniform lowp vec2 noseCenterRight;
uniform lowp vec2 eyebrowCenterRight;
uniform lowp vec2 leftEyeTop;
uniform lowp vec2 leftEyeTop_1;
uniform lowp vec2 leftEyeTop_2;
uniform lowp vec2 leftEyeTop_3;
uniform lowp vec2 leftEyeBottom;
uniform lowp vec2 leftEyeBottom_1;
uniform lowp vec2 leftEyeBottom_2;
uniform lowp vec2 leftEyeBottom_3;
uniform lowp vec2 rightEyeTop;
uniform lowp vec2 rightEyeTop_1;
uniform lowp vec2 rightEyeTop_2;
uniform lowp vec2 rightEyeTop_3;
uniform lowp vec2 rightEyeBottom;
uniform lowp vec2 rightEyeBottom_1;
uniform lowp vec2 rightEyeBottom_2;
uniform lowp vec2 rightEyeBottom_3;


#define ppos52 vec2(286.0/900.0,287.0/600.0)
#define ppos52_1 vec2(316.325/900.0,260.48126/600.0)
#define ppos53 vec2(366.0/900.0,237.0/600.0)
#define ppos53_1 vec2(411.09998/900.0,220.8375/600.0)
#define ppos72 vec2(458.0/900.0,213.0/600.0)
#define ppos72_1 vec2(506.84375/900.0,220.8375/600.0)
#define ppos54 vec2(554.0/900.0,237.0/600.0)
#define ppos54_1 vec2(602.23126/900.0,260.48126/600.0)
#define ppos55 vec2(631.0/900.0,287.0/600.0)
#define ppos55_1 vec2(602.23126 /900.0,314.01874/600.0)
#define ppos56 vec2(554.0/900.0,338.0/600.0)
#define ppos56_1 vec2(506.84375/900.0,353.6625/600.0)
#define ppos73 vec2(458.0/900.0,361.0/600.0)
#define ppos73_1 vec2(411.09998/900.0,353.6625/600.0)
#define ppos57 vec2(366.0/900.0,338.0/600.0)
#define ppos57_1 vec2(316.325/900.0,314.01874/600.0)

#define ppos58 vec2(286.0/900.0,287.0/600.0)
#define ppos58_1 vec2(316.325/900.0,260.48126/600.0)
#define ppos59 vec2(366.0/900.0,237.0/600.0)
#define ppos59_1 vec2(411.09998/900.0,220.8375/600.0)
#define ppos75 vec2(458.0/900.0,213.0/600.0)
#define ppos75_1 vec2(506.84375/900.0,220.8375/600.0)
#define ppos60 vec2(554.0/900.0,237.0/600.0)
#define ppos60_1 vec2(602.23126/900.0,260.48126/600.0)
#define ppos61 vec2(631.0/900.0,287.0/600.0)
#define ppos61_1 vec2(602.23126 /900.0,314.01874/600.0)
#define ppos62 vec2(554.0/900.0,338.0/600.0)
#define ppos62_1 vec2(506.84375/900.0,353.6625/600.0)
#define ppos76 vec2(458.0/900.0,361.0/600.0)
#define ppos76_1 vec2(411.09998/900.0,353.6625/600.0)
#define ppos63 vec2(366.0/900.0,338.0/600.0)
#define ppos63_1 vec2(316.325/900.0,314.01874/600.0)

#define pLeftTop        vec2(0.0,0.0)
#define pRightTop vec2(1.0,0.0)
#define pTop_1      vec2(0.75,0.0)
#define pTop_2      vec2(0.5,0.0)
#define pTop_3      vec2(0.25,0.0)
#define pLeftBottom     vec2(0.0,1.0)
#define pRightBottom    vec2(1.0,1.0)
#define pBottom_1   vec2(0.75,1.0)
#define pBottom_2   vec2(0.5,1.0)
#define pBottom_3   vec2(0.25,1.0)

vec4 plazaX = vec4(0.0);
vec4 plazaY = vec4(0.0);
vec4 plazaZ = vec4(0.0);

uniform lowp float mixCOEF;
uniform vec2 singleStepOffset;
uniform lowp float pic_width;
uniform lowp float pic_height;

float isInPolygon(vec2 p,vec2 ptPolygon[4],float count){
    float nCross = 0.0;
    for (float i = 0.0; i < count; i++)
    {
        vec2 p1 = ptPolygon[int(i)];
        vec2 p2 = ptPolygon[int(mod((i + 1.0), count))];
        // 求解 y=p.y 与 p1p2 的交点
         if ( p1.y == p2.y )
    // p1p2 与 y=p0.y平行
            continue;
            if ( p.y < min(p1.y, p2.y) ) // 交点在p1p2延长线上
                continue;
            if ( p.y >= max(p1.y, p2.y))// 交点在p1p2延长线上
                continue;
            // 求交点的 X 坐标 --------------------------------------------------------------
            float x = (p.y - p1.y) * (p2.x - p1.x) / (p2.y - p1.y) + p1.x;
            if ( x > p.x )
                nCross++; // 只统计单边交点
            }
            // 单边交点为偶数，点在多边形之外 ---
    return mod(nCross,2.0);
}



vec4 blendNormal(vec4 c1, vec4 c2,float mixB)
{
    vec4 outputColor;
    outputColor.r = c1.r*mixB + c2.r * c2.a * (1.0 - c1.a*mixB);
    outputColor.g = c1.g*mixB + c2.g * c2.a * (1.0 - c1.a*mixB);
    outputColor.b = c1.b*mixB + c2.b * c2.a * (1.0 - c1.a*mixB);
    outputColor.a = c1.a + c2.a * (1.0 - c1.a);
    return outputColor;
}

vec4 avgRGBColor(sampler2D inputImageTexture,vec2 textureCoordinate){

  vec2 blurCoordinates[36];
  int num = 0;
  vec4 sampleColor;
  vec4 sampleColorOk;
  for(float i = 0.0;i<6.0;i++){  //行
    for(float j = 0.0;j<6.0;j++){  //列
        blurCoordinates[num] = textureCoordinate.xy + singleStepOffset*1.5*vec2(i-5.0, j-5.0);
        sampleColor += texture2D(inputImageTexture, blurCoordinates[num]);
        num++;
    }
  }
//  pointPick = blurCoordinates;
  sampleColor = sampleColor / 36.0;
  float numOk = 0.0;
  num = 0;
  for(float i = 0.0;i<36.0;i++){  //行
//          blurCoordinates[num] = textureCoordinate.xy + singleStepOffset*1.5*vec2(i-5.0, j-5.0);
          vec4 pointColor = texture2D(inputImageTexture, blurCoordinates[num]);
          if(pointColor.b < sampleColor.b*0.7){
            sampleColorOk += pointColor;
            numOk++;
          }
          num++;
  }
//  return sampleColor;
  if(numOk == 0.0){
    sampleColorOk = sampleColor;
  }else{
    sampleColorOk = sampleColorOk/numOk;
  }

  return sampleColorOk;
}

void main()
{
    vec2 coordinate = vec2(textureCoordinate.x,  textureCoordinate.y);
    vec4 originColor = texture2D(inputImageTexture, textureCoordinate);
    gl_FragColor = originColor;
    vec2 leftEyeAround[4];
    leftEyeAround[0] = noseCenterLeft;
    leftEyeAround[1] = eyebrowCenterLeft;
    leftEyeAround[2] = leftEyeTop;
    leftEyeAround[3] = leftEyeBottom;
    vec2 rightEyeAround[4];

    rightEyeAround[0] = noseCenterRight;
    rightEyeAround[1] = eyebrowCenterRight;
    rightEyeAround[2] = rightEyeTop;
    rightEyeAround[3] = rightEyeBottom;

    vec2 eyeAround[4];
    eyeAround[0] = leftEyeTop;
    eyeAround[1] = leftEyeBottom;
    eyeAround[2] = rightEyeBottom;
    eyeAround[3] = rightEyeTop;

    vec2 pos52   = leftEye[0];
    vec2 pos52_1 = leftEye[1];
    vec2 pos53   = leftEye[2];
    vec2 pos53_1 = leftEye[3];
    vec2 pos72   = leftEye[4];
    vec2 pos72_1 = leftEye[5];
    vec2 pos54   = leftEye[6];
    vec2 pos54_1 = leftEye[7];
    vec2 pos55   = leftEye[8];
    vec2 pos55_1 = leftEye[9];
    vec2 pos56   = leftEye[10];
    vec2 pos56_1 = leftEye[11];
    vec2 pos73   = leftEye[12];
    vec2 pos73_1 = leftEye[13];
    vec2 pos57   = leftEye[14];
    vec2 pos57_1 = leftEye[15];




    vec2 pos58    = rightEye[0];
    vec2 pos58_1  = rightEye[1];
    vec2 pos59    = rightEye[2];
    vec2 pos59_1  = rightEye[3];
    vec2 pos75    = rightEye[4];
    vec2 pos75_1  = rightEye[5];
    vec2 pos60    = rightEye[6];
    vec2 pos60_1  = rightEye[7];
    vec2 pos61    = rightEye[8];
    vec2 pos61_1  = rightEye[9];
    vec2 pos62    = rightEye[10];
    vec2 pos62_1  = rightEye[11];
    vec2 pos76    = rightEye[12];
    vec2 pos76_1  = rightEye[13];
    vec2 pos63    = rightEye[14];
    vec2 pos63_1  = rightEye[15];

        if(isInPolygon(coordinate,eyeAround,4.0) == 1.0 ){

            bool linity0 = sameLineside(eyebrowCenterLeft,noseCenterLeft,leftEyeBottom);  //该函数是为了判断当前点位于哪个区域？
            vec4 avgRBGColor_left = avgRGBColor(inputImageTexture,leftSkinPos);

            bool trinity = false;
            if(linity0){
                        trinity = triangle(leftEyeTop, pos52, leftEyeBottom, pLeftTop, ppos52, pLeftBottom,trinity);
                        trinity = triangle(leftEyeTop, pos52, pos52_1, pLeftTop, ppos52, ppos52_1,trinity);
                        trinity = triangle(leftEyeTop, pos52_1, leftEyeTop_3, pLeftTop, ppos52_1,pTop_3,trinity);
                        trinity = triangle(pos52_1, pos53, leftEyeTop_3, ppos52_1, ppos53, pTop_3,trinity);
                        trinity = triangle(leftEyeTop_3, pos53, pos53_1, pTop_3, ppos53, ppos53_1,trinity);
                        trinity = triangle(leftEyeTop_3, leftEyeTop_2, pos53_1, pTop_3, pTop_2, ppos53_1,trinity);
                        trinity = triangle(pos53_1, pos72, leftEyeTop_2, ppos53_1, ppos72, pTop_2,trinity);
                        trinity = triangle(pos72, pos72_1, leftEyeTop_2, ppos72, ppos72_1, pTop_2,trinity);
                        trinity = triangle(leftEyeTop_2, pos72_1, leftEyeTop_1, pTop_2, ppos72_1, pTop_1,trinity);
                        trinity = triangle(pos72_1, pos54, leftEyeTop_1, ppos72_1, ppos54, pTop_1,trinity);
                        trinity = triangle(pos54, pos54_1, leftEyeTop_1, ppos54, ppos54_1, pTop_1,trinity);
                        trinity = triangle(leftEyeTop_1, pos54_1, eyebrowCenterLeft, pTop_1, ppos54_1,pRightTop,trinity);
                        trinity = triangle(pos54_1, pos55, eyebrowCenterLeft, ppos54_1, ppos55, pRightTop,trinity);
                        trinity = triangle(eyebrowCenterLeft, pos55, noseCenterLeft, pRightTop, ppos55, pRightBottom,trinity);
                        trinity = triangle(pos55, noseCenterLeft, pos55_1, ppos55,pRightBottom, ppos55_1,trinity);
                        trinity = triangle(pos55_1, noseCenterLeft, leftEyeBottom_1, ppos55_1, pRightBottom, pBottom_1,trinity);
                        trinity = triangle(pos55_1, leftEyeBottom_1, pos56, ppos55_1, pBottom_1, ppos56,trinity);
                        trinity = triangle(pos56, leftEyeBottom_1, pos56_1, ppos56, pBottom_1, ppos56_1,trinity);
                        trinity = triangle(pos56_1, leftEyeBottom_1, leftEyeBottom_2, ppos56_1, pBottom_1, pBottom_2,trinity);
                        trinity = triangle(leftEyeBottom_2, pos56_1, pos73, pBottom_2, ppos56_1, ppos73,trinity);
                        trinity = triangle(pos73, leftEyeBottom_2, pos73_1, ppos73, pBottom_2, ppos73_1,trinity);
                        trinity = triangle(pos73_1, leftEyeBottom_2, leftEyeBottom_3, ppos73_1, pBottom_2, pBottom_3,trinity);
                        trinity = triangle(leftEyeBottom_3, pos57, pos73_1, pBottom_3, ppos57, ppos73_1,trinity);
                        trinity = triangle(leftEyeBottom_3, pos57, pos57_1, pBottom_3, ppos57, ppos57_1,trinity);
                        trinity = triangle(leftEyeBottom, leftEyeBottom_3, pos57_1, pLeftBottom, pBottom_3, ppos57_1,trinity);
                        trinity = triangle(leftEyeBottom, pos57_1, pos52, pLeftBottom, ppos57_1, ppos52,trinity);


                        //在进行triangle时，如果当前点位于这个三角形区域内，那么记录下此时人脸这三个点的坐标和这个素材中三点坐标
                        vec2 sample_pos = getTrianglePoint(vec2(plazaX.x,plazaX.y), vec2(plazaY.x,plazaY.y), vec2(plazaZ.x,plazaZ.y), vec2(plazaX.z,plazaX.w), vec2(plazaY.z,plazaY.w), vec2(plazaZ.z,plazaZ.w));

                       vec4 maskColor = texture2D(inputImageTexture2, sample_pos);

                       vec4 blendColor;
                       float ratioD =1.0;
//                       if(isNeedAvoid == 1.0 && (avgRBGColor_left.b - 40.0/255.0 < originColor.b && avgRBGColor_left.b + 40.0/255.0 > originColor.b)
//                                        )
//                       {
//                           float maxD = 40.0/255.0;
//                           float avgOriD = abs(avgRBGColor_left.b - originColor.b);
//                           if(avgOriD > 40.0/255.0){
//                               avgOriD = 40.0/255.0;
//                           }
//                           ratioD = avgOriD/maxD;  //该值越大，越接近1.0   该区域与眉毛颜色差异越大，所以所贴纹理应越不透明
//                           ratioD = pow(ratioD,0.35);
//                       }

                       if(avgRBGColor_left.b+ 0.12 > originColor.b){
                           float maxD = avgRBGColor_left.b + 0.12;
                           float avgOriD = abs(maxD - originColor.b);
                           ratioD = avgOriD/maxD;  //avgOriD该值越大，越接近1.0   该区域越可能是睫毛，所以所贴纹理应越透明
                           ratioD = 1.0 - (pow(ratioD,0.35)-0.2);
                           if(ratioD > 1.0){
                               ratioD = 1.0;
                           }
                       }


                       blendColor = blendNormal(maskColor,originColor,mixCOEF*ratioD);
                       gl_FragColor = blendColor;

            }else{
//                  vec4 avgRBGColor_right = avgRGBColor(inputImageTexture,rightSkinPos);
                  trinity = triangle(eyebrowCenterRight, pos58, noseCenterRight, pLeftTop, ppos58, pLeftBottom,trinity);
                  trinity = triangle(eyebrowCenterRight, pos58, pos58_1, pLeftTop, ppos58, ppos58_1,trinity);
                  trinity = triangle(eyebrowCenterRight, pos58_1, rightEyeTop_3, pLeftTop, ppos58_1,pTop_3,trinity);
                  trinity = triangle(pos58_1, pos59, rightEyeTop_3, ppos58_1, ppos59, pTop_3,trinity);
                  trinity = triangle(rightEyeTop_3, pos59, pos59_1, pTop_3, ppos59, ppos59_1,trinity);
                  trinity = triangle(rightEyeTop_3, rightEyeTop_2, pos59_1, pTop_3, pTop_2, ppos59_1,trinity);
                  trinity = triangle(pos59_1, pos75, rightEyeTop_2, ppos59_1, ppos75, pTop_2,trinity);
                  trinity = triangle(pos75, pos75_1, rightEyeTop_2, ppos75, ppos75_1, pTop_2,trinity);
                  trinity = triangle(rightEyeTop_2, pos75_1, rightEyeTop_1, pTop_2, ppos75_1, pTop_1,trinity);
                  trinity = triangle(pos75_1, pos60, rightEyeTop_1, ppos75_1, ppos60, pTop_1,trinity);
                  trinity = triangle(pos60, pos60_1, rightEyeTop_1, ppos60, ppos60_1, pTop_1,trinity);
                  trinity = triangle(rightEyeTop_1, pos60_1, rightEyeTop, pTop_1, ppos60_1,pRightTop,trinity);
                  trinity = triangle(pos60_1, pos61, rightEyeTop, ppos60_1, ppos61, pRightTop,trinity);
                  trinity = triangle(rightEyeTop, pos61, rightEyeBottom, pRightTop, ppos61, pRightBottom,trinity);
                  trinity = triangle(pos61, rightEyeBottom, pos61_1, ppos61,pRightBottom, ppos61_1,trinity);
                  trinity = triangle(pos61_1, rightEyeBottom, rightEyeBottom_1, ppos61_1, pRightBottom, pBottom_1,trinity);
                  trinity = triangle(pos61_1, rightEyeBottom_1, pos62, ppos61_1, pBottom_1, ppos62,trinity);
                  trinity = triangle(pos62, rightEyeBottom_1, pos62_1, ppos62, pBottom_1, ppos62_1,trinity);
                  trinity = triangle(pos62_1, rightEyeBottom_1, rightEyeBottom_2, ppos62_1, pBottom_1, pBottom_2,trinity);
                  trinity = triangle(rightEyeBottom_2, pos62_1, pos76, pBottom_2, ppos62_1, ppos76,trinity);
                  trinity = triangle(pos76, rightEyeBottom_2, pos76_1, ppos76, pBottom_2, ppos76_1,trinity);
                  trinity = triangle(pos76_1, rightEyeBottom_2, rightEyeBottom_3, ppos76_1, pBottom_2, pBottom_3,trinity);
                  trinity = triangle(rightEyeBottom_3, pos63, pos76_1, pBottom_3, ppos63, ppos76_1,trinity);
                  trinity = triangle(rightEyeBottom_3, pos63, pos63_1, pBottom_3, ppos63, ppos63_1,trinity);
                  trinity = triangle(noseCenterRight, rightEyeBottom_3, pos63_1, pLeftBottom, pBottom_3, ppos63_1,trinity);
                  trinity = triangle(noseCenterRight, pos63_1, pos58, pLeftBottom, ppos63_1, ppos58,trinity);

                        //在进行triangle时，如果当前点位于这个三角形区域内，那么记录下此时人脸这三个点的坐标和这个素材中三点坐标

            vec2 sample_pos = getTrianglePoint(vec2(plazaX.x,plazaX.y), vec2(plazaY.x,plazaY.y), vec2(plazaZ.x,plazaZ.y), vec2(plazaX.z,plazaX.w), vec2(plazaY.z,plazaY.w), vec2(plazaZ.z,plazaZ.w));

            vec4 maskColor = texture2D(inputImageTexture3, sample_pos);

            vec4 blendColor;
            float ratioD =1.0;
            if(avgRBGColor_left.b+ 0.12 > originColor.b){
                    float maxD = avgRBGColor_left.b + 0.12;
                    float avgOriD = abs(maxD - originColor.b);
                    ratioD = avgOriD/maxD;  //avgOriD该值越大，越接近1.0   该区域越可能是睫毛，所以所贴纹理应越透明
                    ratioD = 1.0 - (pow(ratioD,0.35)-0.2);
            }

            if(ratioD > 1.0){
                    ratioD = 1.0;
            }
//            if(avgRBGColor_right.b+ 0.12 > originColor.b){
//                    float maxD = avgRBGColor_right.b + 0.12;
//                    float avgOriD = abs(maxD - originColor.b);
//                    ratioD = avgOriD/maxD;  //avgOriD该值越大，越接近1.0   该区域越可能是睫毛，所以所贴纹理应越透明
//                    ratioD = 1.0 - pow(ratioD,0.35);
//            }


            blendColor = blendNormal(maskColor,originColor,mixCOEF*ratioD);

            gl_FragColor = blendColor;
            }

        }
}