
precision highp float;
varying highp vec2 textureCoordinate;
uniform sampler2D inputImageTexture;
uniform sampler2D inputImageTexture2;

uniform lowp float mixCOEF;

vec4 blendSoft(vec4 base, vec4 overlay)
{
          lowp float nr = base.r;
          if(base.r <= 0.5){
              nr = (2.0 * overlay.r - 1.0)*(base.r - base.r * base.r) + base.r;
          }else{
              nr = (2.0 * overlay.r - 1.0) * (sqrt(base.r) - base.r) + base.r;
          }
         lowp float ng = base.g;
         if(base.g <= 0.5){
             ng = (2.0 * overlay.g - 1.0)*(base.g - base.g * base.g) + base.g;
         }else{
             ng = (2.0 * overlay.g - 1.0) * (sqrt(base.g) - base.g) + base.g;
         }
         lowp float nb = base.b;
         if(base.b <= 0.5){
             nb = (2.0 * overlay.b - 1.0)*(base.b - base.b * base.b) + base.b;
         }else{
             nb = (2.0 * overlay.b - 1.0) * (sqrt(base.b) - base.b) + base.b;
         }
          vec4 newColor = vec4(nr, ng, nb, base.a);
          return newColor;
}

void main()
{
    vec2 coordinate = vec2(textureCoordinate.x,  textureCoordinate.y);
    vec4 maskColor = texture2D(inputImageTexture2, textureCoordinate);

    if(maskColor.r>0.5&&maskColor.g<0.5&&maskColor.b<0.5){
        vec4 originColor = texture2D(inputImageTexture, textureCoordinate);
        vec4 blendColor = blendSoft(originColor,originColor);
        gl_FragColor = vec4 (mix(originColor.rgb, blendColor.rgb, blendColor.a*mixCOEF),1.0);
    }else{
        if(maskColor.r<0.5&&maskColor.g>0.5&&maskColor.b<0.5){
              vec4 originColor = texture2D(inputImageTexture, textureCoordinate);
              vec4 blendColor = blendSoft(originColor,originColor);
              gl_FragColor = vec4 (mix(originColor.rgb, blendColor.rgb, blendColor.a*mixCOEF),1.0);
        }else{
            gl_FragColor = texture2D(inputImageTexture, textureCoordinate);
        }
    }
}