
precision highp float;
varying highp vec2 textureCoordinate;
uniform sampler2D inputImageTexture;

uniform lowp vec2 upLip[11];
uniform lowp vec2 downLip[11];

float isInPolygon(vec2 p,vec2 ptPolygon[11],float count){
    float nCross = 0.0;
    for (float i = 0.0; i < count; i++)
    {
        vec2 p1 = ptPolygon[int(i)];
        vec2 p2 = ptPolygon[int(mod((i + 1.0), count))];
        // 求解 y=p.y 与 p1p2 的交点
         if ( p1.y == p2.y )
    // p1p2 与 y=p0.y平行
            continue;
            if ( p.y < min(p1.y, p2.y) ) // 交点在p1p2延长线上
                continue;
            if ( p.y >= max(p1.y, p2.y))// 交点在p1p2延长线上
                continue;
            // 求交点的 X 坐标 --------------------------------------------------------------
            float x = (p.y - p1.y) * (p2.x - p1.x) / (p2.y - p1.y) + p1.x;
            if ( x > p.x )
                nCross++; // 只统计单边交点
            }
            // 单边交点为偶数，点在多边形之外 ---
    return mod(nCross,2.0);
}

vec4 blendColourFilter(vec4 base, vec4 overlay){
    vec4 newColor = vec4(1.0 - (1.0 - overlay.rgb)*(1.0 - base.rgb),base.a);
    return newColor;
}

void main()
{
    vec2 coordinate = vec2(textureCoordinate.x,  textureCoordinate.y);
    float isUpLib = isInPolygon(coordinate,upLip,11.0);
    if(isUpLib == 1.0){
        
       vec4 originColor = texture2D(inputImageTexture, textureCoordinate);
       vec4 blendColor = blendColourFilter(originColor,originColor);

       float currentWithCenter = distance(coordinate,vec2((upLip[3].x + upLip[8].x)/2.0,(upLip[3].y + upLip[8].y)/2.0));
       float radiusWithCenter = distance(vec2((upLip[3].x + upLip[8].x)/2.0,(upLip[3].y + upLip[8].y)/2.0),upLip[8])/2.0 * 1.6;

       float mixNum = 0.04;//0.34
    
       float ratio_r = (currentWithCenter - radiusWithCenter * 0.7) / radiusWithCenter;
       if(ratio_r > 0.3){
         ratio_r = 0.3;

         mixNum *= (1.0 - ratio_r);
       }

       float new_r = originColor.rgb.r + mixNum;

       gl_FragColor = vec4(new_r, originColor.rgb.g, originColor.rgb.b ,1.0);

    }else{
       float isDownLib = isInPolygon(coordinate,downLip,11.0);
       if(isDownLib == 1.0){
          vec4 originColor = texture2D(inputImageTexture, textureCoordinate);
          vec4 blendColor = blendColourFilter(originColor,originColor);
           
          float currentWithCenter = distance(coordinate,vec2((upLip[3].x + upLip[8].x)/2.0,(upLip[3].y + upLip[8].y)/2.0));
          float radiusWithCenter = distance(vec2((upLip[3].x + upLip[8].x)/2.0,(upLip[3].y + upLip[8].y)/2.0),upLip[8])/2.0 * 1.6;
       
          float mixNum = 0.04;
       
          float ratio_r = (currentWithCenter - radiusWithCenter * 0.7) / radiusWithCenter;
          if(ratio_r > 0.3){
             ratio_r = 0.3;
           
             mixNum *= (1.0 - ratio_r);
          }
       
          float new_r = originColor.rgb.r + mixNum;
       
          gl_FragColor = vec4(new_r, originColor.rgb.g, originColor.rgb.b ,1.0);

       }else{
          gl_FragColor = texture2D(inputImageTexture, textureCoordinate);
       }
    }
}
