
precision highp float;
varying highp vec2 textureCoordinate;
uniform sampler2D inputImageTexture;
uniform sampler2D inputImageTexture2;  //acne blackwhite
uniform sampler2D inputImageTexture3;  //acne exclude

uniform float singleStepH;
uniform float singleStepV;
uniform vec2 singleStepOffset;

const lowp vec3 weight = vec3(0.299,0.587,0.114);

bool isWhite(vec4 color){
    return color.b>0.5;
}
vec4 getColor(vec2 coord){
    vec4 color=texture2D(inputImageTexture2,coord);
    return color;
}
bool isBlack(vec2 coord){
    vec4 color=texture2D(inputImageTexture2,coord);
    return color.r<0.5;
}

bool isAcne(vec4 color,vec2 coordinate){
    vec4 wbColor = color;
    int isKeyArea = 0;
    int l_count = 0;
    int r_count = 0;
    int t_count = 0;
    int b_count = 0;
    
    int lt_count = 0;
    int lb_count = 0;
    int rt_count = 0;
    int rb_count = 0;
    
    float smallRectRCoef = 1.0;
    vec2 smallRectR = singleStepOffset*smallRectRCoef;
    //    float bigRectRCoef = 18.0;
    vec2 bigRectR = smallRectR*13.0;
    int maxNum = 26;
    float step_max = 4.0;
    
    if(isWhite(wbColor)){
        //l
        vec2 l_currentPos = vec2(0.0,0.0);
        for(int i = 0;i< maxNum;i++){
            
            if(i == 0){
                l_currentPos = coordinate;
            }
            vec4 pos_color = texture2D(inputImageTexture2, vec2(l_currentPos.x-smallRectR.x,l_currentPos.y));
            if(isWhite(pos_color)){  //白色
                l_count++;
                l_currentPos = vec2(l_currentPos.x-smallRectR.x,l_currentPos.y);
                continue;
            }
            
            pos_color = texture2D(inputImageTexture2, vec2(l_currentPos.x-smallRectR.x,l_currentPos.y-smallRectR.y));
            if(isWhite(pos_color)){  //白色
                l_count++;
                l_currentPos = vec2(l_currentPos.x-smallRectR.x,l_currentPos.y-smallRectR.y);
                continue;
            }
            
            pos_color = texture2D(inputImageTexture2, vec2(l_currentPos.x-smallRectR.x,l_currentPos.y+smallRectR.y));
            if(isWhite(pos_color)){  //白色
                l_count++;
                l_currentPos = vec2(l_currentPos.x-smallRectR.x,l_currentPos.y+smallRectR.y);
                continue;
            }
            
            pos_color = texture2D(inputImageTexture2, vec2(l_currentPos.x-smallRectR.x,l_currentPos.y-2.0*smallRectR.y));
            if(isWhite(pos_color)){  //白色
                l_count++;
                l_currentPos = vec2(l_currentPos.x-smallRectR.x,l_currentPos.y-2.0*smallRectR.y);
                continue;
            }
            
            pos_color = texture2D(inputImageTexture2, vec2(l_currentPos.x-smallRectR.x,l_currentPos.y+2.0*smallRectR.y));
            if(isWhite(pos_color)){  //白色
                l_count++;
                l_currentPos = vec2(l_currentPos.x-smallRectR.x,l_currentPos.y+2.0*smallRectR.y);
                continue;
            }
            
            pos_color = texture2D(inputImageTexture2, vec2(l_currentPos.x-smallRectR.x,l_currentPos.y+smallRectR.y));
            if(isWhite(pos_color)){  //白色
                l_count++;
                l_currentPos = vec2(l_currentPos.x-smallRectR.x,l_currentPos.y+smallRectR.y);
                continue;
            }
            
            pos_color = texture2D(inputImageTexture2, vec2(l_currentPos.x-smallRectR.x,l_currentPos.y-3.0*smallRectR.y));
            if(isWhite(pos_color)){  //白色
                l_count++;
                l_currentPos = vec2(l_currentPos.x-smallRectR.x,l_currentPos.y-3.0*smallRectR.y);
                continue;
            }
            
            pos_color = texture2D(inputImageTexture2, vec2(l_currentPos.x-smallRectR.x,l_currentPos.y+3.0*smallRectR.y));
            if(isWhite(pos_color)){  //白色
                l_count++;
                l_currentPos = vec2(l_currentPos.x-smallRectR.x,l_currentPos.y+3.0*smallRectR.y);
                continue;
            }
            
            pos_color = texture2D(inputImageTexture2, vec2(l_currentPos.x-smallRectR.x,l_currentPos.y-4.0*smallRectR.y));
            if(isWhite(pos_color)){  //白色
                l_count++;
                l_currentPos = vec2(l_currentPos.x-smallRectR.x,l_currentPos.y-4.0*smallRectR.y);
                continue;
            }
            
            pos_color = texture2D(inputImageTexture2, vec2(l_currentPos.x-smallRectR.x,l_currentPos.y+4.0*smallRectR.y));
            if(isWhite(pos_color)){  //白色
                l_count++;
                l_currentPos = vec2(l_currentPos.x-smallRectR.x,l_currentPos.y+4.0*smallRectR.y);
                continue;
            }
            break;
        }
        
        //r
        vec2 r_currentPos = vec2(0.0,0.0);
        for(int i = 0;i< maxNum;i++){
            if(i == 0){
                r_currentPos = textureCoordinate;
            }
            vec4 pos_color = texture2D(inputImageTexture2, vec2(r_currentPos.x+smallRectR.x,r_currentPos.y));
            if(isWhite(pos_color)){  //白色
                r_count++;
                r_currentPos = vec2(r_currentPos.x+smallRectR.x,r_currentPos.y);
                continue;
            }
            
            pos_color = texture2D(inputImageTexture2, vec2(r_currentPos.x+smallRectR.x,r_currentPos.y - smallRectR.y));
            if(isWhite(pos_color)){  //白色
                r_count++;
                r_currentPos = vec2(r_currentPos.x+smallRectR.x,r_currentPos.y - smallRectR.y);
                continue;
            }
            
            pos_color = texture2D(inputImageTexture2, vec2(r_currentPos.x+smallRectR.x,r_currentPos.y+smallRectR.y));
            if(isWhite(pos_color)){  //白色
                r_count++;
                r_currentPos = vec2(r_currentPos.x+smallRectR.x,r_currentPos.y+smallRectR.y);
                continue;
            }
            
            pos_color = texture2D(inputImageTexture2, vec2(r_currentPos.x+smallRectR.x,r_currentPos.y - 2.0*smallRectR.y));
            if(isWhite(pos_color)){  //白色
                r_count++;
                r_currentPos = vec2(r_currentPos.x+smallRectR.x,r_currentPos.y - 2.0*smallRectR.y);
                continue;
            }
            
            pos_color = texture2D(inputImageTexture2, vec2(r_currentPos.x+smallRectR.x,r_currentPos.y+2.0*smallRectR.y));
            if(isWhite(pos_color)){  //白色
                r_count++;
                r_currentPos = vec2(r_currentPos.x+smallRectR.x,r_currentPos.y+2.0*smallRectR.y);
                continue;
            }
            
            pos_color = texture2D(inputImageTexture2, vec2(r_currentPos.x+smallRectR.x,r_currentPos.y - 3.0*smallRectR.y));
            if(isWhite(pos_color)){  //白色
                r_count++;
                r_currentPos = vec2(r_currentPos.x+smallRectR.x,r_currentPos.y - 3.0*smallRectR.y);
                continue;
            }
            
            pos_color = texture2D(inputImageTexture2, vec2(r_currentPos.x+smallRectR.x,r_currentPos.y+3.0*smallRectR.y));
            if(isWhite(pos_color)){  //白色
                r_count++;
                r_currentPos = vec2(r_currentPos.x+smallRectR.x,r_currentPos.y+3.0*smallRectR.y);
                continue;
            }
            
            pos_color = texture2D(inputImageTexture2, vec2(r_currentPos.x+smallRectR.x,r_currentPos.y - 4.0*smallRectR.y));
            if(isWhite(pos_color)){  //白色
                r_count++;
                r_currentPos = vec2(r_currentPos.x+smallRectR.x,r_currentPos.y - 4.0*smallRectR.y);
                continue;
            }
            
            pos_color = texture2D(inputImageTexture2, vec2(r_currentPos.x+smallRectR.x,r_currentPos.y+4.0*smallRectR.y));
            if(isWhite(pos_color)){  //白色
                r_count++;
                r_currentPos = vec2(r_currentPos.x+smallRectR.x,r_currentPos.y+4.0*smallRectR.y);
                continue;
            }
            break;
        }
        
        //t
        vec2 t_currentPos = vec2(0.0,0.0);
        for(int i = 0;i< maxNum;i++){
            
            if(i == 0){
                t_currentPos = textureCoordinate;
            }
            vec4 pos_color = texture2D(inputImageTexture2, vec2(t_currentPos.x,t_currentPos.y - smallRectR.y));
            if(isWhite(pos_color)){  //白色
                t_count++;
                t_currentPos = vec2(t_currentPos.x,t_currentPos.y - smallRectR.y);
                continue;
            }
            
            pos_color = texture2D(inputImageTexture2, vec2(t_currentPos.x-smallRectR.x,t_currentPos.y-smallRectR.y));
            if(isWhite(pos_color)){  //白色
                t_count++;
                t_currentPos = vec2(t_currentPos.x-smallRectR.x,t_currentPos.y-smallRectR.y);
                continue;
            }
            
            pos_color = texture2D(inputImageTexture2, vec2(t_currentPos.x+smallRectR.x,t_currentPos.y-smallRectR.y));
            if(isWhite(pos_color)){  //白色
                t_count++;
                t_currentPos = vec2(t_currentPos.x+smallRectR.x,t_currentPos.y-smallRectR.y);
                continue;
            }
            
            pos_color = texture2D(inputImageTexture2, vec2(t_currentPos.x-2.0*smallRectR.x,t_currentPos.y-smallRectR.y));
            if(isWhite(pos_color)){  //白色
                t_count++;
                t_currentPos = vec2(t_currentPos.x-2.0*smallRectR.x,t_currentPos.y-smallRectR.y);
                continue;
            }
            
            pos_color = texture2D(inputImageTexture2, vec2(t_currentPos.x+2.0*smallRectR.x,t_currentPos.y-smallRectR.y));
            if(isWhite(pos_color)){  //白色
                t_count++;
                t_currentPos = vec2(t_currentPos.x+2.0*smallRectR.x,t_currentPos.y-smallRectR.y);
                continue;
            }
            
            pos_color = texture2D(inputImageTexture2, vec2(t_currentPos.x-3.0*smallRectR.x,t_currentPos.y-smallRectR.y));
            if(isWhite(pos_color)){  //白色
                t_count++;
                t_currentPos = vec2(t_currentPos.x-3.0*smallRectR.x,t_currentPos.y-smallRectR.y);
                continue;
            }
            
            pos_color = texture2D(inputImageTexture2, vec2(t_currentPos.x+3.0*smallRectR.x,t_currentPos.y-smallRectR.y));
            if(isWhite(pos_color)){  //白色
                t_count++;
                t_currentPos = vec2(t_currentPos.x+3.0*smallRectR.x,t_currentPos.y-smallRectR.y);
                continue;
            }
            
            pos_color = texture2D(inputImageTexture2, vec2(t_currentPos.x-4.0*smallRectR.x,t_currentPos.y-smallRectR.y));
            if(isWhite(pos_color)){  //白色
                t_count++;
                t_currentPos = vec2(t_currentPos.x-4.0*smallRectR.x,t_currentPos.y-smallRectR.y);
                continue;
            }
            
            pos_color = texture2D(inputImageTexture2, vec2(t_currentPos.x+4.0*smallRectR.x,t_currentPos.y-smallRectR.y));
            if(isWhite(pos_color)){  //白色
                t_count++;
                t_currentPos = vec2(t_currentPos.x+4.0*smallRectR.x,t_currentPos.y-smallRectR.y);
                continue;
            }
            break;
        }
        
        //b
        vec2 b_currentPos = vec2(0.0,0.0);
        for(int i = 0;i< maxNum;i++){
            if(i == 0){
                b_currentPos = textureCoordinate;
            }
            vec4 pos_color = texture2D(inputImageTexture2, vec2(b_currentPos.x,b_currentPos.y+smallRectR.y));
            if(isWhite(pos_color)){  //白色
                b_count++;
                b_currentPos = vec2(b_currentPos.x,b_currentPos.y+smallRectR.y);
                continue;
            }
            
            pos_color = texture2D(inputImageTexture2, vec2(b_currentPos.x-smallRectR.x,b_currentPos.y+smallRectR.y));
            if(isWhite(pos_color)){  //白色
                b_count++;
                b_currentPos = vec2(b_currentPos.x-smallRectR.x,b_currentPos.y+smallRectR.y);
                continue;
            }
            
            pos_color = texture2D(inputImageTexture2, vec2(b_currentPos.x+smallRectR.x,b_currentPos.y+smallRectR.y));
            if(isWhite(pos_color)){  //白色
                b_count++;
                b_currentPos = vec2(b_currentPos.x+smallRectR.x,b_currentPos.y+smallRectR.y);
                continue;
            }
            
            pos_color = texture2D(inputImageTexture2, vec2(b_currentPos.x-2.0*smallRectR.x,b_currentPos.y+smallRectR.y));
            if(isWhite(pos_color)){  //白色
                b_count++;
                b_currentPos = vec2(b_currentPos.x-2.0*smallRectR.x,b_currentPos.y+smallRectR.y);
                continue;
            }
            
            pos_color = texture2D(inputImageTexture2, vec2(b_currentPos.x+2.0*smallRectR.x,b_currentPos.y+smallRectR.y));
            if(isWhite(pos_color)){  //白色
                b_count++;
                b_currentPos = vec2(b_currentPos.x+2.0*smallRectR.x,b_currentPos.y+smallRectR.y);
                continue;
            }
            
            pos_color = texture2D(inputImageTexture2, vec2(b_currentPos.x-3.0*smallRectR.x,b_currentPos.y+smallRectR.y));
            if(isWhite(pos_color)){  //白色
                b_count++;
                b_currentPos = vec2(b_currentPos.x-3.0*smallRectR.x,b_currentPos.y+smallRectR.y);
                continue;
            }
            
            pos_color = texture2D(inputImageTexture2, vec2(b_currentPos.x+3.0*smallRectR.x,b_currentPos.y+smallRectR.y));
            if(isWhite(pos_color)){  //白色
                b_count++;
                b_currentPos = vec2(b_currentPos.x+3.0*smallRectR.x,b_currentPos.y+smallRectR.y);
                continue;
            }
            
            pos_color = texture2D(inputImageTexture2, vec2(b_currentPos.x-4.0*smallRectR.x,b_currentPos.y+smallRectR.y));
            if(isWhite(pos_color)){  //白色
                b_count++;
                b_currentPos = vec2(b_currentPos.x-4.0*smallRectR.x,b_currentPos.y+smallRectR.y);
                continue;
            }
            
            pos_color = texture2D(inputImageTexture2, vec2(b_currentPos.x+4.0*smallRectR.x,b_currentPos.y+smallRectR.y));
            if(isWhite(pos_color)){  //白色
                b_count++;
                b_currentPos = vec2(b_currentPos.x+4.0*smallRectR.x,b_currentPos.y+smallRectR.y);
                continue;
            }
            break;
        }
        
        if((l_count+r_count) >= maxNum || (t_count+b_count) >= maxNum){
            return false;
        }else{
            return true;
        }
        
    }else{
        return false;
    }
}

vec2 getAcneNeighbor(vec2 acneCoord,vec2 direction){
    vec2 acneNeighbor=acneCoord+direction;
    while(isWhite(getColor(acneNeighbor))
          &&acneNeighbor.x>0.05
          &&acneNeighbor.x<0.95
          &&acneNeighbor.y>0.05
          &&acneNeighbor.y<0.95){
        acneNeighbor=acneNeighbor+direction;
    }
    return acneNeighbor;
}
vec4 wipeAcne(vec4 color,vec2 coord){
    vec2 left=getAcneNeighbor(coord,vec2(-singleStepH,0.0));
    vec2 right=getAcneNeighbor(coord,vec2(singleStepH,0.0));
    vec2 top=getAcneNeighbor(coord,vec2(0.0,-singleStepV));
    vec2 bottom=getAcneNeighbor(coord,vec2(0.0,singleStepV));
    
    float disLeft=abs(distance(left,coord));
    float disRight=abs(distance(right,coord));
    float disTop=abs(distance(top,coord));
    float disBottom=abs(distance(bottom,coord));
    float totalDis=disLeft+disRight+disTop+disBottom;
    
    float weightLeft=1.0-disLeft/totalDis;
    float weightRight=1.0-disRight/totalDis;
    float weightTop=1.0-disTop/totalDis;
    float weightBottom=1.0-disBottom/totalDis;
    float toatalWeight=weightLeft+weightRight+weightTop+weightBottom;
    
    weightLeft=weightLeft/toatalWeight;
    weightRight=weightRight/toatalWeight;
    weightTop=weightTop/toatalWeight;
    weightBottom=weightBottom/toatalWeight;
    
    vec4 colorLeft=texture2D(inputImageTexture,left);
    vec4 colorRight=texture2D(inputImageTexture,right);
    vec4 colorTop=texture2D(inputImageTexture,top);
    vec4 colorBottom=texture2D(inputImageTexture,bottom);
    
    vec4 result=colorLeft*weightLeft+colorRight*weightRight+colorTop*weightTop+colorBottom*weightBottom;
    return result;
}


void main()
{
    gl_FragColor = texture2D(inputImageTexture,textureCoordinate);
    vec4 curColor=texture2D(inputImageTexture2,textureCoordinate);
    vec4 inCludeColor=texture2D(inputImageTexture3,textureCoordinate);
    vec2 curCoord=vec2(textureCoordinate.x,textureCoordinate.y);
    if(inCludeColor.g >0.5){
        if(isWhite(curColor)&&isAcne(curColor,curCoord)){
//        if(curColor.b>0.0){
              gl_FragColor=wipeAcne(curColor,textureCoordinate);
//            gl_FragColor=vec4(1.0,0.0,0.0,1.0);
        }
    }
}
