precision highp float;
varying highp vec2 textureCoordinate;
uniform sampler2D inputImageTexture;
uniform sampler2D inputImageTexture2;

uniform lowp vec2 pos43;
uniform lowp vec2 pos49;

bool isBlack(vec4 color){
    return color.r<0.5;
}

bool isRed(vec4 color){
    return color.r>0.5;
}

vec4 getColor(vec2 coord){
    vec4 color=texture2D(inputImageTexture2,coord);
    return color;
}


vec2 getTopPos(vec2 currentPos,vec2 topStep){
    vec2 currentXY_top = currentPos;

//    while(isRed(getColor(currentXY_top))){
//         currentXY_top=currentXY_top+topStep;
//    }

    int n = 400;
    for(int i = 0;i<n;i++){
        if(!isRed(getColor(currentXY_top))){
            break;
        }
        currentXY_top=currentXY_top+topStep;
    }

    return currentXY_top;
}

vec2 getBottomPos(vec2 currentPos,vec2 bottomStep){
    vec2 currentXY_bottom = currentPos;

//    while(isRed(getColor(currentXY_bottom))){
//         currentXY_bottom=currentXY_bottom+bottomStep;
//    }
//    bool flag = true;
//    while(flag){
//        if(isRed(getColor(currentXY_bottom))){
//            flag = false;
//        }
//    }
    int n = 400;
    for(int i = 0;i<n;i++){
        if(!isRed(getColor(currentXY_bottom))){
            break;
        }
        currentXY_bottom=currentXY_bottom+bottomStep;
    }
    return currentXY_bottom;
}

void main()
{

    gl_FragColor = texture2D(inputImageTexture, textureCoordinate);
    vec2 topStep = (pos43 - pos49)*0.15*0.1;
    vec2 topPos = getTopPos(textureCoordinate,topStep);
    vec2 bottomStep = (pos49 - pos43)*0.15*0.1;
    vec2 bottomPos = getBottomPos(textureCoordinate,bottomStep);

    float disTop = distance(topPos,textureCoordinate);
    float disBottom = distance(bottomPos,textureCoordinate);
//
    float weightTop = 0.0;
    if(disTop!=0.0||disBottom!=0.0){
          weightTop = disBottom/(disTop+disBottom);
    }
    float weightBottom =  1.0 - weightTop;

    vec4 colorTop=texture2D(inputImageTexture,topPos);

//    gl_FragColor = colorTop;
    vec4 colorBottom=texture2D(inputImageTexture,bottomPos);

    vec4 replaceColor = colorTop*weightTop+colorBottom*weightBottom;

//    vec4 replaceColor =  getReplaceColor(textureCoordinate);
    gl_FragColor = vec4(replaceColor.rgb,1.0);
}