
precision highp float;
varying highp vec2 textureCoordinate;
uniform sampler2D inputImageTexture;
uniform sampler2D inputImageTexture2;  //高斯模糊
uniform sampler2D inputImageTexture3;  //sc mask
uniform sampler2D inputImageTexture4;  //pouch mask
//uniform lowp vec2 leftEye[5];
//uniform lowp vec2 rightEye[5];
uniform vec2 pos52;
uniform vec2 pos73;
uniform vec2 pos78;
uniform vec2 pos80;
uniform vec2 pos4;

uniform vec2 pos61;
uniform vec2 pos76;
uniform vec2 pos79;
uniform vec2 pos81;
uniform vec2 pos28;

uniform vec2 pos43;
uniform vec2 pos49;

uniform lowp vec2 leftCenter;
uniform lowp vec2 rightCenter;
uniform lowp float mixCOEF;
//uniform lowp vec2 leftSkinPos;
//uniform lowp vec2 rightSkinPos;
//uniform highp vec2 singleStepOffset;
uniform lowp float pic_width;
uniform lowp float pic_height;
uniform lowp vec4 avgRBGColor_left;
uniform lowp vec4 avgRBGColor_right;

#define ppos52 vec2(0.1746,0.4648)
#define ppos73 vec2(0.311,0.4936)
#define ppos78 vec2(0.4473,0.4760)
#define ppos80 vec2(0.4114,0.5894)
#define ppos4 vec2(0.1339,0.5750)

#define ppos61 vec2(0.8157,0.472)
#define ppos76 vec2(0.6985,0.4872)
#define ppos79 vec2(0.5789,0.4824)
#define ppos81 vec2(0.5837,0.583)
#define ppos28 vec2(0.8564,0.5814)

vec4 plazaX = vec4(0.0);
vec4 plazaY = vec4(0.0);
vec4 plazaZ = vec4(0.0);


float isInPolygon(vec2 p,vec2 ptPolygon[5],float count){
    float nCross = 0.0;
    for (float i = 0.0; i < count; i++)
    {
        vec2 p1 = ptPolygon[int(i)];
        vec2 p2 = ptPolygon[int(mod((i + 1.0), count))];
        // 求解 y=p.y 与 p1p2 的交点
         if ( p1.y == p2.y )
    // p1p2 与 y=p0.y平行
            continue;
            if ( p.y < min(p1.y, p2.y) ) // 交点在p1p2延长线上
                continue;
            if ( p.y >= max(p1.y, p2.y))// 交点在p1p2延长线上
                continue;
            // 求交点的 X 坐标 --------------------------------------------------------------
            float x = (p.y - p1.y) * (p2.x - p1.x) / (p2.y - p1.y) + p1.x;
            if ( x > p.x )
                nCross++; // 只统计单边交点
            }
            // 单边交点为偶数，点在多边形之外 ---
    return mod(nCross,2.0);
}

//==============================================================================
bool isLineSideLeft(vec2 lp1, vec2 lp2, vec2 point)
{

    vec2 P1 = lp1;
    vec2 P2 = lp2;
    if(((P2.y - P1.y) * point.x + (P1.x-P2.x) * point.y + (P2.x*P1.y - P1.x*P2.y))<0.0){
        //left
        return false;
    }
    return true;
}


bool triangle(vec2 A, vec2 B, vec2 C, vec2 a, vec2 b, vec2 c)
{
    vec2 v0 = C - A ;
    vec2 v1 = B - A ;
    vec2 v2 = textureCoordinate - A ;

    float dot00 = dot(v0,v0) ;
    float dot01 = dot(v0,v1) ;
    float dot02 = dot(v0,v2) ;
    float dot11 = dot(v1,v1) ;
    float dot12 = dot(v1,v2) ;

    float inverDeno = 1.0 / (dot00 * dot11 - dot01 * dot01) ;

    float u = (dot11 * dot02 - dot01 * dot12) * inverDeno ;
    if (u < 0.0 || u > 1.0) // if u out of range, return directly
    {
    return false ;
    }

    float v = (dot00 * dot12 - dot01 * dot02) * inverDeno ;
    if (v < 0.0 || v > 1.0) // if v out of range, return directly
    {
    return false ;
    }

    if(u + v <=1.0)
    {
    plazaX = vec4(A.x,A.y,a.x,a.y);
    plazaY = vec4(B.x,B.y,b.x,b.y);
    plazaZ = vec4(C.x,C.y,c.x,c.y);
    return true;
    }

    return false;
}


vec2 getTrianglePoint(vec2 A, vec2 B, vec2 C, vec2 a, vec2 b, vec2 c)
{
    vec2 AP = textureCoordinate - A;
    vec2 BC = C - B;

    float apxy = AP.x/AP.y;
    float bcyx = BC.y/BC.x;

    vec2 D = vec2(0.0);
    D.y = apxy*bcyx;
    D.x = B.y*apxy - A.y*apxy - B.x*D.y + A.x;
    D.x /= 1.0 - D.y;
    D.y = D.x*bcyx - B.x*bcyx + B.y;

    apxy = length(D - B)/length(BC);
    bcyx = length(AP)/length(D - A);

    D = b + (c-b)*apxy;
    D = a + (D-a)*bcyx;

    return D;
}


void main()
{
    vec2 coordinate = vec2(textureCoordinate.x,  textureCoordinate.y);
    vec4 originColor = texture2D(inputImageTexture, textureCoordinate);
    vec4 blurColor = texture2D(inputImageTexture2, textureCoordinate);
    vec4 maskColor = texture2D(inputImageTexture3, textureCoordinate);
    vec4 pouchMaskColor = texture2D(inputImageTexture4, textureCoordinate);

    gl_FragColor = originColor;
    vec4 resultColor = originColor;

    float realPosLeftX1 = pos73.x*pic_width;
    float realPosLeftX2 = pos78.x*pic_width;
    float realPosLeftY1 = pos73.y*pic_height;
    float realPosLeftY2 = pos78.y*pic_height;
    float radiusLeft = pow((realPosLeftX1 - realPosLeftX2)*(realPosLeftX1 - realPosLeftX2)+(realPosLeftY1 - realPosLeftY2)*(realPosLeftY1 - realPosLeftY2),0.5)*0.8;

    float realPosRightX1 = pos76.x*pic_width;
    float realPosRightX2 = pos79.x*pic_width;
    float realPosRightY1 = pos76.y*pic_height;
    float realPosRightY2 = pos79.y*pic_height;
    float radiusRight = pow((realPosRightX1 - realPosRightX2)*(realPosRightX1 - realPosRightX2)+(realPosRightY1 - realPosRightY2)*(realPosRightY1 - realPosRightY2),0.5)*0.8;

    float realPosXCurrent = coordinate.x*pic_width;
    float realPosYCurrent = coordinate.y*pic_height;

    float realPosXCenterLeft = leftCenter.x*pic_width;
    float realPosYCenterLeft = leftCenter.y*pic_height;

    float realPosXCenterRight = rightCenter.x*pic_width;
    float realPosYCenterRight = rightCenter.y*pic_height;

    float disWithLeft = pow((realPosXCurrent - realPosXCenterLeft)*(realPosXCurrent - realPosXCenterLeft)+(realPosYCurrent - realPosYCenterLeft)*(realPosYCurrent - realPosYCenterLeft),0.5);
    float disWithRight = pow((realPosXCurrent - realPosXCenterRight)*(realPosXCurrent - realPosXCenterRight)+(realPosYCurrent - realPosYCenterRight)*(realPosYCurrent - realPosYCenterRight),0.5);


    bool trinity = false;


    if(pouchMaskColor.r > 0.5){

        if(isLineSideLeft(pos43,pos49,coordinate)){
                trinity = triangle(pos52, pos4, pos73, ppos52, ppos4, ppos73);
                trinity = triangle(pos73, pos4, pos80, ppos73, ppos4, ppos80);
                trinity = triangle(pos73, pos80, pos78, ppos73, ppos80, ppos78);
                //在进行triangle时，如果当前点位于这个三角形区域内，那么记录下此时人脸这三个点的坐标和这个素材中三点坐标
                vec2 sample_pos = getTrianglePoint(vec2(plazaX.x,plazaX.y), vec2(plazaY.x,plazaY.y), vec2(plazaZ.x,plazaZ.y), vec2(plazaX.z,plazaX.w), vec2(plazaY.z,plazaY.w), vec2(plazaZ.z,plazaZ.w));
                vec4 maskAlpha = texture2D(inputImageTexture3, sample_pos);

                float greenRatio = 0.0;
                if(avgRBGColor_left.g - originColor.g > 0.0){
                   greenRatio = (avgRBGColor_left.g - originColor.g)/0.2509;
                   if(greenRatio > 1.0){
                       greenRatio = 1.0;
                   }
                }
                vec4 blendColor = vec4 (mix(originColor.rgb, blurColor.rgb,pow(maskAlpha.a+0.2,3.0)*mixCOEF),1.0);

                float ratio_r = 0.0;
                 if(disWithLeft < radiusLeft){
                    ratio_r = 1.0 - pow(disWithLeft/radiusLeft,1.0);
                    if(ratio_r > 1.0){
                      ratio_r = 1.0;
                    }
                    if(ratio_r < 0.0){
                      ratio_r = 0.0;
                    }
                }
                float brightness_ratio = greenRatio*0.12*maskAlpha.a*ratio_r;
                blendColor = vec4(blendColor.r+brightness_ratio,blendColor.g+brightness_ratio,blendColor.b+brightness_ratio,blendColor.a);

                gl_FragColor = blendColor;
         }else{
                trinity = triangle(pos61, pos28, pos76, ppos61, ppos28, ppos76);
                trinity = triangle(pos76, pos28, pos81, ppos76, ppos28, ppos81);
                trinity = triangle(pos76, pos81, pos79, ppos76, ppos81, ppos79);
                //在进行triangle时，如果当前点位于这个三角形区域内，那么记录下此时人脸这三个点的坐标和这个素材中三点坐标

                vec2 sample_pos = getTrianglePoint(vec2(plazaX.x,plazaX.y), vec2(plazaY.x,plazaY.y), vec2(plazaZ.x,plazaZ.y), vec2(plazaX.z,plazaX.w), vec2(plazaY.z,plazaY.w), vec2(plazaZ.z,plazaZ.w));

                vec4 maskAlpha = texture2D(inputImageTexture3, sample_pos);


                float greenRatio = 0.0;
                if(avgRBGColor_right.g - originColor.g > 0.0){
                   greenRatio = (avgRBGColor_right.g - originColor.g)/0.2509;
                   if(greenRatio > 1.0){
                       greenRatio = 1.0;
                   }
                }


                vec4 blendColor = vec4 (mix(originColor.rgb, blurColor.rgb,pow(maskAlpha.a+0.2,3.0)*mixCOEF),1.0);

                float ratio_r = 0.0;
                 if(disWithRight < radiusRight){
                    ratio_r = 1.0 - pow(disWithRight/radiusRight,1.0);
                    if(ratio_r > 1.0){
                      ratio_r = 1.0;
                    }
                    if(ratio_r < 0.0){
                      ratio_r = 0.0;
                    }
                }

                float brightness_ratio = greenRatio*0.12*maskAlpha.a*ratio_r;
                blendColor = vec4(blendColor.r+brightness_ratio,blendColor.g+brightness_ratio,blendColor.b+brightness_ratio,blendColor.a);
                gl_FragColor = blendColor;
         }

    }
}
