precision highp float;

varying highp vec2 textureCoordinate;
varying highp vec2 texture2Coordinate;//face region mask coord

uniform sampler2D inputImageTexture;//face region mask
uniform sampler2D inputImageTexture2; //阴影
uniform sampler2D inputImageTexture3;   //高光

uniform float isDrawHighLight;
uniform float mShadowRatio;
uniform float mHighLightRatio;

void main(){
    vec4 faceRegionMaskColor=texture2D(inputImageTexture, texture2Coordinate);

    vec4 texture2MaskColor = texture2D(inputImageTexture2, textureCoordinate);
    vec4 texture3MaskColor = texture2D(inputImageTexture3, textureCoordinate);
    vec4 texture2MixColor=vec4(169.0/255.0,118.0/255.0,95.0/255.0,1.0);
    vec4 texture3MixColor=vec4(249.0/255.0,236.0/255.0,232.0/255.0,1.0);
    if(faceRegionMaskColor.r>0.0){
        if(isDrawHighLight>0.5){
            gl_FragColor = vec4(texture2MixColor.rgb*texture2MaskColor.r*mShadowRatio*faceRegionMaskColor.r,texture2MaskColor.r*mShadowRatio*faceRegionMaskColor.r);
        }
        else{
            gl_FragColor = vec4(texture3MixColor.rgb*texture3MaskColor.r*mHighLightRatio*faceRegionMaskColor.r,texture3MaskColor.r*mHighLightRatio*faceRegionMaskColor.r);
        }
    }else{
        gl_FragColor = vec4(0.0,0.0,0.0,0.0);
    }
}
