
precision highp float;
varying highp vec2 textureCoordinate;
uniform sampler2D inputImageTexture;
uniform sampler2D inputImageTexture2;
uniform float mixCOEF;
uniform vec2 singleStepOffset;

void main()
{
    vec2 coordinate = vec2(textureCoordinate.x,  textureCoordinate.y);
    vec4 originColor = texture2D(inputImageTexture, textureCoordinate);
    vec4 maskColor = texture2D(inputImageTexture2, textureCoordinate);

    if(maskColor.r > 0.5){
        float isLip = 1.0;
        if(
           ((originColor.b < originColor.r)&& (originColor.b < originColor.g)
            && (originColor.r > 0.4 && originColor.g > 0.4))
           ){
            isLip = 0.0;

            if(originColor.r > originColor.g){
                if(originColor.r > originColor.g*1.5){
                    isLip = 1.0;
                }
            }
        }

        if(isLip == 0.0){
            float coefR = 1.0+mixCOEF/2.5;
            float coefG = 1.0+mixCOEF/2.0;
            float coefB = mixCOEF+1.0;

            float reusltR=originColor.r*coefR;
            if(reusltR>1.0){
            reusltR=1.0;
            }

            float resultG=originColor.g*coefG;
            if(resultG>1.0){
            resultG=1.0;
            }

            float resultB=originColor.b*coefB;
            if(resultB>1.0){
            resultB=1.0;
            }
            gl_FragColor=vec4(reusltR,resultG,resultB,originColor.a);

        }else{
            gl_FragColor = originColor;
        }
    }else{
        gl_FragColor = originColor;
    }
    
}
