
precision highp float;
varying highp vec2 textureCoordinate;
uniform sampler2D inputImageTexture;
uniform sampler2D inputImageTexture2;

//uniform lowp vec2 leftEye[5];
//uniform lowp vec2 rightEye[5];

uniform lowp vec2 pos78;
uniform lowp vec2 pos73_82;
uniform lowp vec2 pos7_52;
uniform lowp vec2 pos52;
uniform lowp vec2 pos73;

uniform lowp vec2 pos79;
uniform lowp vec2 pos76_83;
uniform lowp vec2 pos25_61;
uniform lowp vec2 pos61;
uniform lowp vec2 pos76;

uniform lowp vec4 leftSkinAvgColor;
uniform lowp vec4 rightSkinAvgColor;

uniform lowp float mixCOEF;
//uniform lowp vec2 leftSkinPos;
//uniform lowp vec2 rightSkinPos;
uniform vec2 singleStepOffset;

//float isInPolygon(vec2 p,vec2 ptPolygon[5],float count){
//    float nCross = 0.0;
//    for (float i = 0.0; i < count; i++)
//    {
//        vec2 p1 = ptPolygon[int(i)];
//        vec2 p2 = ptPolygon[int(mod((i + 1.0), count))];
//        // 求解 y=p.y 与 p1p2 的交点
//         if ( p1.y == p2.y )
//    // p1p2 与 y=p0.y平行
//            continue;
//            if ( p.y < min(p1.y, p2.y) ) // 交点在p1p2延长线上
//                continue;
//            if ( p.y >= max(p1.y, p2.y))// 交点在p1p2延长线上
//                continue;
//            // 求交点的 X 坐标 --------------------------------------------------------------
//            float x = (p.y - p1.y) * (p2.x - p1.x) / (p2.y - p1.y) + p1.x;
//            if ( x > p.x )
//                nCross++; // 只统计单边交点
//            }
//            // 单边交点为偶数，点在多边形之外 ---
//    return mod(nCross,2.0);
//}

//vec4 avgRGBColor(sampler2D inputImageTexture,vec2 textureCoordinate){
//
//  vec2 blurCoordinates[100];
//  int num = 0;
//  vec4 sampleColor;
//  for(float i = 0.0;i<10.0;i++){  //行
//    for(float j = 0.0;j<10.0;j++){  //列
//        blurCoordinates[num] = textureCoordinate.xy + singleStepOffset*vec2(i-5.0, j-5.0);
//        sampleColor += texture2D(inputImageTexture, blurCoordinates[num]);
//        num++;
//    }
//  }
//   sampleColor = sampleColor / 100.0;
//  return sampleColor;
//}

vec4 blendColourFilter(vec4 base, vec4 overlay){
    vec4 newColor = vec4(1.0 - (1.0 - overlay.rgb)*(1.0 - base.rgb),base.a);
    return newColor;
}

bool isLeftEye(vec2 pos){
    vec4 posColor = texture2D(inputImageTexture2, pos);
    if(posColor.r<0.5&&posColor.g<0.5&&posColor.b>0.5){
        return true;
    }
    return false;
}

bool isRightEye(vec2 pos){
    vec4 posColor = texture2D(inputImageTexture2, pos);
    if(posColor.r>0.5&&posColor.g>0.5&&posColor.b>0.5){
        return true;
    }
    return false;
}

void main()
{
    vec2 coordinate = vec2(textureCoordinate.x,  textureCoordinate.y);
    bool isInLeft = isLeftEye(coordinate);
    if(isInLeft){
        vec4 originColor = texture2D(inputImageTexture, textureCoordinate);

        vec4 avgRBGColor_left = leftSkinAvgColor;
         if(originColor.z < avgRBGColor_left.z){
                float currentWithCenter = distance(coordinate,vec2((pos52.x+pos78.x)/2.0,(pos52.y+pos78.y)/2.0));
                float radiusWithCenter = distance(vec2((pos52.x+pos78.x)/2.0,(pos52.y+pos78.y)/2.0),pos52)/2.0*1.6;
                float mixNum;
                vec4 blendColor = blendColourFilter(originColor,originColor);
                float ratio = originColor.z/avgRBGColor_left.z;
                if(originColor.z/avgRBGColor_left.z < 0.6){
                      ratio = 0.6;
                }
                mixNum = (1.0 - ratio)*0.34;
//                if(currentWithCenter > radiusWithCenter*0.7){
                    float ratio_r = (currentWithCenter - radiusWithCenter*0.7)/radiusWithCenter;
                    if(ratio_r > 0.3){
                        ratio_r = 0.3;
                    }
                    mixNum *= (1.0 - ratio_r*3.333);
                    gl_FragColor = vec4 (mix(originColor.rgb, blendColor.rgb, blendColor.a*mixNum),1.0);
//                }else{
//                    gl_FragColor = vec4 (mix(originColor.rgb, blendColor.rgb, blendColor.a*mixNum),1.0);
//                }

          }else{
            gl_FragColor = originColor;
         }
    }else{
        bool isInRight = isRightEye(coordinate);
        if(isInRight){
              vec4 originColor = texture2D(inputImageTexture, textureCoordinate);

                vec4 avgRBGColor_right = rightSkinAvgColor;

//              if((originColor.x+originColor.y+originColor.z) < (avgRBGColor_right.x+avgRBGColor_right.y+avgRBGColor_right.z)){
              if(originColor.z < avgRBGColor_right.z){

                          float currentWithCenter = distance(coordinate,vec2((pos61.x+pos79.x)/2.0,(pos61.y+pos79.y)/2.0));
                          float radiusWithCenter = distance(vec2((pos61.x+pos79.x)/2.0,(pos61.y+pos79.y)/2.0),pos61)/2.0*1.6;
                          float mixNum;
                          vec4 blendColor = blendColourFilter(originColor,originColor);
                          float ratio = originColor.z/avgRBGColor_right.z;
                          if(originColor.z/avgRBGColor_right.z < 0.6){
                              ratio = 0.6;
                          }
                          mixNum = (1.0 - ratio)*0.34;
//                          if(currentWithCenter > radiusWithCenter*0.7){
                               float ratio_r = (currentWithCenter - radiusWithCenter*0.7)/radiusWithCenter;
                               if(ratio_r > 0.3){
                                    ratio_r = 0.3;
                               }
                               mixNum *= (1.0 - ratio_r*3.333);
                               gl_FragColor = vec4 (mix(originColor.rgb, blendColor.rgb, blendColor.a*mixNum),1.0);
//                          }
//                          gl_FragColor = vec4 (mix(originColor.rgb, blendColor.rgb, blendColor.a*mixNum),1.0);
              }else{
                gl_FragColor = originColor;
              }
        }else{
            gl_FragColor = texture2D(inputImageTexture, textureCoordinate);
        }
    }
}